OAuth2::Session -

# class OAuth2::Session

- OAuth2::Session
- Reference
- Object

## Overview

An OAuth2 session makes it easy to implement APIs that need to refresh an access token once its expired before executing an HTTP request.

## Defined in:

## Constructors

- .new(oauth2_client : Client, access_token : AccessToken, expires_at = Time.utc, &callback : OAuth2::Session -> )

  Creates an `OAuth2::Session`.

## Instance Method Summary

- #access_token : AccessToken
- #authenticate(http_client)

  Authenticates an `HTTP::Client`, refreshing the access token if it is expired.

- #expires_at : Time?
- #oauth2_client : Client

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash(hasher)
hash hash, inspect(io : IO) : Nil
inspect : String inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try, unsafe_as(type : T.class) forall T unsafe_as

### Constructor methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io : String | IO) : self from_yaml

## Constructor Detail

def self.new(oauth2_client : Client, access_token : AccessToken, expires_at = Time.utc, &callback : OAuth2::Session -> ) #

Creates an `OAuth2::Session`.

Params:

- oauth2_client: the OAuth2::Client used to refresh an access token.
- access_token: the OAuth2::AccessToken to make requests.
- expires_at: the Time when the access token expires.
- callback: invoked when an access token is refreshed, giving you a chance to persist it.

## Instance Method Detail

def access_token : AccessToken #
def authenticate(http_client) #

Authenticates an `HTTP::Client`, refreshing the access token if it is expired.

Invoke this method on an `HTTP::Client` before executing an HTTP request.

def expires_at : Time? #
def oauth2_client : Client #